
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Training Colab &#8212; Battery SOH 2022 documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Normalisation Training Colab" href="normalisation_training.html" />
    <link rel="prev" title="Google Colabs" href="Colabs.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 current active nav-item">
 <a class="reference internal nav-link" href="Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    <p class="caption">
 <span class="caption-text">
  Contents:
 </span>
</p>
<ul class="current nav bd-sidenav">
 <li class="toctree-l1 current active">
  <a class="current reference internal" href="#">
   Training Colab
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="normalisation_training.html">
   Normalisation Training
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="lstm_chemistry_training.html">
   LSTM Chemistry Training
  </a>
 </li>
</ul>

  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                

<nav id="bd-toc-nav">
    
</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  
<style>
/* CSS for nbsphinx extension */

/* remove conflicting styling from Sphinx themes */
div.nbinput.container div.prompt *,
div.nboutput.container div.prompt *,
div.nbinput.container div.input_area pre,
div.nboutput.container div.output_area pre,
div.nbinput.container div.input_area .highlight,
div.nboutput.container div.output_area .highlight {
    border: none;
    padding: 0;
    margin: 0;
    box-shadow: none;
}

div.nbinput.container > div[class*=highlight],
div.nboutput.container > div[class*=highlight] {
    margin: 0;
}

div.nbinput.container div.prompt *,
div.nboutput.container div.prompt * {
    background: none;
}

div.nboutput.container div.output_area .highlight,
div.nboutput.container div.output_area pre {
    background: unset;
}

div.nboutput.container div.output_area div.highlight {
    color: unset;  /* override Pygments text color */
}

/* avoid gaps between output lines */
div.nboutput.container div[class*=highlight] pre {
    line-height: normal;
}

/* input/output containers */
div.nbinput.container,
div.nboutput.container {
    display: -webkit-flex;
    display: flex;
    align-items: flex-start;
    margin: 0;
    width: 100%;
}
@media (max-width: 540px) {
    div.nbinput.container,
    div.nboutput.container {
        flex-direction: column;
    }
}

/* input container */
div.nbinput.container {
    padding-top: 5px;
}

/* last container */
div.nblast.container {
    padding-bottom: 5px;
}

/* input prompt */
div.nbinput.container div.prompt pre {
    color: #307FC1;
}

/* output prompt */
div.nboutput.container div.prompt pre {
    color: #BF5B3D;
}

/* all prompts */
div.nbinput.container div.prompt,
div.nboutput.container div.prompt {
    width: 4.5ex;
    padding-top: 5px;
    position: relative;
    user-select: none;
}

div.nbinput.container div.prompt > div,
div.nboutput.container div.prompt > div {
    position: absolute;
    right: 0;
    margin-right: 0.3ex;
}

@media (max-width: 540px) {
    div.nbinput.container div.prompt,
    div.nboutput.container div.prompt {
        width: unset;
        text-align: left;
        padding: 0.4em;
    }
    div.nboutput.container div.prompt.empty {
        padding: 0;
    }

    div.nbinput.container div.prompt > div,
    div.nboutput.container div.prompt > div {
        position: unset;
    }
}

/* disable scrollbars on prompts */
div.nbinput.container div.prompt pre,
div.nboutput.container div.prompt pre {
    overflow: hidden;
}

/* input/output area */
div.nbinput.container div.input_area,
div.nboutput.container div.output_area {
    -webkit-flex: 1;
    flex: 1;
    overflow: auto;
}
@media (max-width: 540px) {
    div.nbinput.container div.input_area,
    div.nboutput.container div.output_area {
        width: 100%;
    }
}

/* input area */
div.nbinput.container div.input_area {
    border: 1px solid #e0e0e0;
    border-radius: 2px;
    /*background: #f5f5f5;*/
}

/* override MathJax center alignment in output cells */
div.nboutput.container div[class*=MathJax] {
    text-align: left !important;
}

/* override sphinx.ext.imgmath center alignment in output cells */
div.nboutput.container div.math p {
    text-align: left;
}

/* standard error */
div.nboutput.container div.output_area.stderr {
    background: #fdd;
}

/* ANSI colors */
.ansi-black-fg { color: #3E424D; }
.ansi-black-bg { background-color: #3E424D; }
.ansi-black-intense-fg { color: #282C36; }
.ansi-black-intense-bg { background-color: #282C36; }
.ansi-red-fg { color: #E75C58; }
.ansi-red-bg { background-color: #E75C58; }
.ansi-red-intense-fg { color: #B22B31; }
.ansi-red-intense-bg { background-color: #B22B31; }
.ansi-green-fg { color: #00A250; }
.ansi-green-bg { background-color: #00A250; }
.ansi-green-intense-fg { color: #007427; }
.ansi-green-intense-bg { background-color: #007427; }
.ansi-yellow-fg { color: #DDB62B; }
.ansi-yellow-bg { background-color: #DDB62B; }
.ansi-yellow-intense-fg { color: #B27D12; }
.ansi-yellow-intense-bg { background-color: #B27D12; }
.ansi-blue-fg { color: #208FFB; }
.ansi-blue-bg { background-color: #208FFB; }
.ansi-blue-intense-fg { color: #0065CA; }
.ansi-blue-intense-bg { background-color: #0065CA; }
.ansi-magenta-fg { color: #D160C4; }
.ansi-magenta-bg { background-color: #D160C4; }
.ansi-magenta-intense-fg { color: #A03196; }
.ansi-magenta-intense-bg { background-color: #A03196; }
.ansi-cyan-fg { color: #60C6C8; }
.ansi-cyan-bg { background-color: #60C6C8; }
.ansi-cyan-intense-fg { color: #258F8F; }
.ansi-cyan-intense-bg { background-color: #258F8F; }
.ansi-white-fg { color: #C5C1B4; }
.ansi-white-bg { background-color: #C5C1B4; }
.ansi-white-intense-fg { color: #A1A6B2; }
.ansi-white-intense-bg { background-color: #A1A6B2; }

.ansi-default-inverse-fg { color: #FFFFFF; }
.ansi-default-inverse-bg { background-color: #000000; }

.ansi-bold { font-weight: bold; }
.ansi-underline { text-decoration: underline; }


div.nbinput.container div.input_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight].math,
div.nboutput.container div.output_area.rendered_html,
div.nboutput.container div.output_area > div.output_javascript,
div.nboutput.container div.output_area:not(.rendered_html) > img{
    padding: 5px;
    margin: 0;
}

/* fix copybtn overflow problem in chromium (needed for 'sphinx_copybutton') */
div.nbinput.container div.input_area > div[class^='highlight'],
div.nboutput.container div.output_area > div[class^='highlight']{
    overflow-y: hidden;
}

/* hide copybtn icon on prompts (needed for 'sphinx_copybutton') */
.prompt a.copybtn {
    display: none;
}

/* Some additional styling taken form the Jupyter notebook CSS */
div.rendered_html table {
  border: none;
  border-collapse: collapse;
  border-spacing: 0;
  color: black;
  font-size: 12px;
  table-layout: fixed;
}
div.rendered_html thead {
  border-bottom: 1px solid black;
  vertical-align: bottom;
}
div.rendered_html tr,
div.rendered_html th,
div.rendered_html td {
  text-align: right;
  vertical-align: middle;
  padding: 0.5em 0.5em;
  line-height: normal;
  white-space: normal;
  max-width: none;
  border: none;
}
div.rendered_html th {
  font-weight: bold;
}
div.rendered_html tbody tr:nth-child(odd) {
  background: #f5f5f5;
}
div.rendered_html tbody tr:hover {
  background: rgba(66, 165, 245, 0.2);
}
</style>
<div class="section" id="Training-Colab">
<h1><strong>Training Colab</strong><a class="headerlink" href="#Training-Colab" title="Permalink to this headline">¶</a></h1>
<p>This Colab serves for model training.</p>
<p>The following google drive link corresponds to the most recent project folder(you’ll need to ask for access): <a class="reference external" href="https://drive.google.com/drive/folders/1iZtHF_jrLXeIBbAIk5AXBtS-5Ib6sCQ7?usp=sharing">https://drive.google.com/drive/folders/1iZtHF_jrLXeIBbAIk5AXBtS-5Ib6sCQ7?usp=sharing</a></p>
<p>The following cell includes the bare minimum to mount google drive to google colab so that the files can be directly called. The <code class="docutils literal notranslate"><span class="pre">root_path</span></code> may have to be updated to the latest <code class="docutils literal notranslate"><span class="pre">Battery_SOH</span></code> folder.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">google.colab</span> <span class="kn">import</span> <span class="n">drive</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">torch</span> <span class="k">as</span> <span class="nn">th</span>

<span class="c1"># Mounting google drive</span>
<span class="n">drive</span><span class="o">.</span><span class="n">mount</span><span class="p">(</span><span class="s1">&#39;/content/gdrive&#39;</span><span class="p">)</span>
<span class="n">folder_name</span> <span class="o">=</span> <span class="s1">&#39;Battery_SOH_final&#39;</span>
<span class="c1"># The root path will change depending on the latest &#39;bakcup&#39;</span>
<span class="n">root_path</span> <span class="o">=</span> <span class="s1">&#39;gdrive/My Drive/battery_soh/&#39;</span> <span class="o">+</span> <span class="n">folder_name</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="n">root_path</span><span class="p">)</span>
<span class="n">device</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">device</span><span class="p">(</span><span class="s1">&#39;cuda:0&#39;</span> <span class="k">if</span> <span class="n">th</span><span class="o">.</span><span class="n">cuda</span><span class="o">.</span><span class="n">is_available</span><span class="p">()</span> <span class="k">else</span> <span class="s1">&#39;cpu&#39;</span><span class="p">)</span>
<span class="n">device</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Drive already mounted at /content/gdrive; to attempt to forcibly remount, call drive.mount(&#34;/content/gdrive&#34;, force_remount=True).
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
device(type=&#39;cuda&#39;, index=0)
</pre></div></div>
</div>
<p>The cell should output something like:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>Mounted at /content/gdrive
device(type=&#39;cuda&#39;, index=0)
</pre></div>
</div>
<p>If the second line says <code class="docutils literal notranslate"><span class="pre">device(type='cpu')</span></code> then you should change your environment options above for GPU for faster results.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span># Imports:
# Libraries:
!pip install PyAstronomy
from torch.utils.data import DataLoader, Dataset
from datetime import datetime
import re
import random
import seaborn as sns
sns.set()

# SOH Modules:
# Battery Classes:
from Coin_Classes import *
from MIT_Classes import *
from Nasa_Classes import *
# Models:
from LSTM import *
import LSTM_with_norm as wn #
import LSTM_chemistry as chem #
# Training and Report related:
from Training import *
from Load_Save import *
import DistributionPlots as dp
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Requirement already satisfied: PyAstronomy in /usr/local/lib/python3.7/dist-packages (0.16.0)
Requirement already satisfied: numpy in /usr/local/lib/python3.7/dist-packages (from PyAstronomy) (1.19.5)
Requirement already satisfied: six in /usr/local/lib/python3.7/dist-packages (from PyAstronomy) (1.15.0)
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Useful dictionaries:</span>
<span class="kn">import</span> <span class="nn">main</span>

<span class="n">dataset_path_dict</span> <span class="o">=</span> <span class="n">main</span><span class="o">.</span><span class="n">path_dict</span>

<span class="c1"># Batteries to exclude from training and validation datasets:</span>
<span class="n">ignore_dict</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s1">&#39;NASA&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B0049.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0050.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0051.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0052.txt&#39;</span><span class="p">],</span>
    <span class="s1">&#39;MIT&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)</span><span class="o">.</span><span class="n">zfill</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span><span class="o">+</span><span class="s1">&#39;.txt&#39;</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">15</span><span class="p">,</span> <span class="mi">48</span><span class="p">)],</span>
    <span class="c1"># There are no problems with these ^ batteries, it&#39;s just that MIT&#39;s dataset</span>
    <span class="c1"># is huge, so I don&#39;t include all of the batteries in the validation dataset</span>
    <span class="s1">&#39;Tarascon Coin&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B0008.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0019.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0023.txt&#39;</span><span class="p">],</span>
<span class="p">}</span>

<span class="c1"># Batteries to include in the training dataset:</span>
<span class="n">train_dict</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s1">&#39;NASA&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B0006.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0030.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0038.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0039.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0041.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0045.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0055.txt&#39;</span><span class="p">,],</span> <span class="c1"># 4ºC</span>
    <span class="s1">&#39;MIT&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B0000.txt&#39;</span><span class="p">],</span>
    <span class="s1">&#39;Tarascon Coin&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B0001.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0003.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0005.txt&#39;</span><span class="p">,</span>
                      <span class="s1">&#39;B0006.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0012.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0013.txt&#39;</span><span class="p">,</span>
                      <span class="s1">&#39;B0014.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0018.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0020.txt&#39;</span><span class="p">,</span>
                      <span class="s1">&#39;B0021.txt&#39;</span><span class="p">]</span>
<span class="p">}</span>

<span class="n">dataset_function_dict</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s1">&#39;normal&#39;</span><span class="p">:</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">,</span>
    <span class="s1">&#39;chemistry&#39;</span><span class="p">:</span> <span class="n">chem</span><span class="o">.</span><span class="n">Torch_Dataset_LSTM</span><span class="p">,</span>
    <span class="s1">&#39;with norm&#39;</span><span class="p">:</span> <span class="n">wn</span><span class="o">.</span><span class="n">Torch_Dataset_LSTM</span>
<span class="p">}</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># initializing dataset related variables:</span>
<span class="n">fixed_len</span> <span class="o">=</span> <span class="mi">150</span>         <span class="c1">## Recommended values</span>
<span class="n">time_step</span> <span class="o">=</span> <span class="kc">None</span>        <span class="c1">##</span>
<span class="n">batch_size</span> <span class="o">=</span> <span class="mi">1</span>          <span class="c1">##</span>
<span class="n">adimensionalize</span><span class="o">=</span><span class="kc">True</span>    <span class="c1">##</span>
<span class="n">norm_type</span> <span class="o">=</span> <span class="s1">&#39;zscore&#39;</span>    <span class="c1">##</span>

<span class="n">DELTA</span> <span class="o">=</span> <span class="mi">10</span>              <span class="c1">###</span>

<span class="n">cycle_lim</span> <span class="o">=</span> <span class="mf">1e6</span>                     <span class="c1">### depends on your analysis</span>
<span class="n">dataset_name</span> <span class="o">=</span> <span class="s1">&#39;NASA&#39;</span>               <span class="c1">### NASA; MIT; Tarascon Coin.</span>
<span class="n">LSTM_version</span> <span class="o">=</span> <span class="mi">4</span>                    <span class="c1">### 1 - 5</span>
<span class="n">LSTM_variant</span> <span class="o">=</span> <span class="s1">&#39;normal&#39;</span>             <span class="c1">### normal; chemistry; with norm</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Dataset creation:</span>
<span class="n">dataset_function</span> <span class="o">=</span> <span class="n">dataset_function_dict</span><span class="p">[</span><span class="n">LSTM_variant</span><span class="p">]</span>
<span class="k">try</span><span class="p">:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="n">dataset_path_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">])</span>
<span class="k">except</span><span class="p">:</span>
    <span class="k">raise</span> <span class="ne">FileNotFoundError</span><span class="p">(</span><span class="s2">&quot;Current directory: &quot;</span><span class="p">,</span> <span class="n">os</span><span class="o">.</span><span class="n">getcwd</span><span class="p">())</span>

<span class="n">files</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">()</span>    <span class="c1"># All files in the folder</span>
<span class="n">file_list</span> <span class="o">=</span> <span class="p">[]</span>          <span class="c1"># List with the valid files</span>

<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">files</span><span class="p">:</span>
    <span class="n">match</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;B\d</span><span class="si">{4}</span><span class="s1">.txt&#39;</span><span class="p">,</span> <span class="n">file_name</span><span class="p">)</span> <span class="c1"># Only take into acount</span>
                                                <span class="c1"># the battery files</span>
    <span class="k">if</span> <span class="n">match</span> <span class="o">==</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">continue</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">file_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>
<span class="n">file_list</span><span class="o">.</span><span class="n">sort</span><span class="p">()</span>


<span class="n">ignore</span> <span class="o">=</span> <span class="n">ignore_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">]</span>
<span class="n">train</span> <span class="o">=</span> <span class="n">train_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">]</span>

<span class="c1"># Training files:</span>
<span class="n">Train_list</span> <span class="o">=</span> <span class="p">[]</span>
<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
    <span class="k">if</span> <span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">train</span><span class="p">:</span>
        <span class="k">continue</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

        <span class="n">Train_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>

<span class="c1"># Validation files:</span>
<span class="n">Valid_list</span> <span class="o">=</span> <span class="p">[]</span>
<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">train</span><span class="p">)</span> <span class="ow">and</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">ignore</span><span class="p">):</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
        <span class="n">Valid_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>

<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../../../&#39;</span><span class="p">)</span>

<span class="c1"># wn datasets:</span>
<span class="n">train_dataset</span> <span class="o">=</span> <span class="n">dataset_function</span><span class="p">(</span>
    <span class="n">Train_list</span><span class="p">,</span> <span class="n">DELTA</span><span class="p">,</span> <span class="n">LSTM_version</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">,</span>
    <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span> <span class="n">norm_type</span><span class="o">=</span><span class="n">norm_type</span><span class="p">,</span> <span class="n">adimensionalize</span><span class="o">=</span><span class="n">adimensionalize</span><span class="p">,</span>
    <span class="n">cycle_lim</span><span class="o">=</span><span class="n">cycle_lim</span>
    <span class="p">)</span>

<span class="n">valid_dataset</span> <span class="o">=</span> <span class="n">dataset_function</span><span class="p">(</span>
    <span class="n">Valid_list</span><span class="p">,</span> <span class="n">DELTA</span><span class="p">,</span> <span class="n">LSTM_version</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
    <span class="n">time_step</span><span class="o">=</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">time_step</span><span class="p">,</span> <span class="n">norm</span><span class="o">=</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">norm</span><span class="p">,</span>
    <span class="c1"># time_step and norm are carried from the training dataset</span>
    <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span> <span class="n">adimensionalize</span><span class="o">=</span><span class="n">adimensionalize</span><span class="p">,</span> <span class="n">cycle_lim</span><span class="o">=</span><span class="n">cycle_lim</span>
    <span class="p">)</span>


<span class="c1"># Loaders:</span>
<span class="k">if</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">fixed_len</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
    <span class="n">train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>
                                <span class="n">shuffle</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
    <span class="n">sim_train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>
                                  <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">valid_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">valid_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>
                                <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
<span class="k">else</span><span class="p">:</span>
    <span class="n">train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="n">batch_size</span><span class="p">,</span>
                                <span class="n">shuffle</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
    <span class="n">sim_train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span>
                                  <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">train_dataset</span><span class="p">),</span> <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">valid_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">valid_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">valid_dataset</span><span class="p">),</span>
                              <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Time step: (in seconds) 31.23419761657715
B0006
B0030
B0038
B0039
B0041
B0045
B0055
483
B0005
B0007
B0018
B0025
B0026
B0027
B0028
B0029
B0031
B0032
B0033
B0034
B0036
B0040
B0042
B0043
B0044
B0046
B0047
B0048
B0053
B0054
B0056
1938
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Model</span>
<span class="n">HIDDEN_DIM</span> <span class="o">=</span> <span class="mi">50</span>
<span class="n">DROPOUT</span> <span class="o">=</span> <span class="mi">0</span>
<span class="n">pool_type</span> <span class="o">=</span> <span class="s1">&#39;bi_mean&#39;</span>

<span class="c1"># Definition of the model (should agree with LSTM_version and LSTM_variant)</span>
<span class="c1"># LSTM_variant dictates the module: chemistry: chem., with norm: wn.</span>
<span class="c1"># LSTM_version dictates the version: 1 - 3 is LSTM_v1, 4 - 5 is LSTM_v4</span>

<span class="n">Model</span> <span class="o">=</span> <span class="n">LSTM_v4</span><span class="p">(</span><span class="n">DELTA</span><span class="p">,</span> <span class="n">HIDDEN_DIM</span><span class="p">,</span> <span class="n">pooling_layer</span><span class="o">=</span><span class="n">pool_type</span><span class="p">,</span>
               <span class="n">drop_out</span><span class="o">=</span><span class="n">DROPOUT</span><span class="p">,</span> <span class="n">version</span> <span class="o">=</span> <span class="n">LSTM_version</span><span class="p">,</span>
               <span class="n">norm</span> <span class="o">=</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">norm</span>
               <span class="p">)</span>

<span class="n">Model</span> <span class="o">=</span> <span class="n">Model</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>
<span class="c1"># Preview of the model&#39;s performance as is (should be bad for untrained models):</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">sim_train_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/sphinx_training_colab_8_0.png" src="../_images/sphinx_training_colab_8_0.png" />
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/sphinx_training_colab_8_1.png" src="../_images/sphinx_training_colab_8_1.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Training loop:</span>
<span class="n">Nb_Epochs</span> <span class="o">=</span> <span class="mi">75</span>          <span class="c1">###</span>
<span class="n">Learning_Rate</span> <span class="o">=</span> <span class="mf">5e-6</span>    <span class="c1">###</span>


<span class="n">Train_info</span><span class="p">,</span> <span class="n">_</span><span class="p">,</span> <span class="n">_</span><span class="p">,</span> <span class="n">date</span> <span class="o">=</span> <span class="n">Train</span><span class="p">(</span>
    <span class="n">train_loader</span><span class="p">,</span> <span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">Nb_Epochs</span><span class="p">,</span> <span class="n">plot_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
    <span class="n">LR</span><span class="o">=</span><span class="n">Learning_Rate</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">sim_loader</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
    <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">remove_bool</span><span class="o">=</span><span class="kc">True</span>
    <span class="p">)</span>

<span class="k">if</span> <span class="n">Model</span><span class="o">.</span><span class="n">variant</span> <span class="o">==</span> <span class="s1">&#39;with norm&#39;</span><span class="p">:</span>
    <span class="c1"># updating the Model&#39;s norm attribute after training in case report=False:</span>
    <span class="n">Model</span><span class="o">.</span><span class="n">update_norm</span><span class="p">()</span>

<span class="c1"># Best epoch&#39;s performance:</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">sim_train_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">block</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">)</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">block</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
1 . Training loss:  tensor(0.9947)
1 . Validation loss:  tensor(0.5609)
2 . Training loss:  tensor(0.9728)
2 . Validation loss:  tensor(0.5426)
3 . Training loss:  tensor(0.9488)
3 . Validation loss:  tensor(0.5212)
4 . Training loss:  tensor(0.9212)
4 . Validation loss:  tensor(0.4947)
5 . Training loss:  tensor(0.8889)
5 . Validation loss:  tensor(0.4635)
6 . Training loss:  tensor(0.8507)
6 . Validation loss:  tensor(0.4249)
7 . Training loss:  tensor(0.8066)
7 . Validation loss:  tensor(0.3816)
8 . Training loss:  tensor(0.7592)
8 . Validation loss:  tensor(0.3366)
9 . Training loss:  tensor(0.7108)
9 . Validation loss:  tensor(0.2916)
10 . Training loss:  tensor(0.6628)
10 . Validation loss:  tensor(0.2497)
11 . Training loss:  tensor(0.6174)
11 . Validation loss:  tensor(0.2127)
12 . Training loss:  tensor(0.5761)
12 . Validation loss:  tensor(0.1826)
13 . Training loss:  tensor(0.5390)
13 . Validation loss:  tensor(0.1583)
14 . Training loss:  tensor(0.5061)
14 . Validation loss:  tensor(0.1391)
15 . Training loss:  tensor(0.4761)
15 . Validation loss:  tensor(0.1244)
16 . Training loss:  tensor(0.4482)
16 . Validation loss:  tensor(0.1128)
17 . Training loss:  tensor(0.4218)
17 . Validation loss:  tensor(0.1031)
18 . Training loss:  tensor(0.3966)
18 . Validation loss:  tensor(0.0953)
19 . Training loss:  tensor(0.3723)
19 . Validation loss:  tensor(0.0889)
20 . Training loss:  tensor(0.3486)
20 . Validation loss:  tensor(0.0834)
21 . Training loss:  tensor(0.3257)
21 . Validation loss:  tensor(0.0790)
22 . Training loss:  tensor(0.3035)
22 . Validation loss:  tensor(0.0752)
23 . Training loss:  tensor(0.2821)
23 . Validation loss:  tensor(0.0718)
24 . Training loss:  tensor(0.2615)
24 . Validation loss:  tensor(0.0695)
25 . Training loss:  tensor(0.2420)
25 . Validation loss:  tensor(0.0678)
26 . Training loss:  tensor(0.2235)
26 . Validation loss:  tensor(0.0665)
27 . Training loss:  tensor(0.2061)
27 . Validation loss:  tensor(0.0656)
28 . Training loss:  tensor(0.1899)
28 . Validation loss:  tensor(0.0656)
29 . Training loss:  tensor(0.1749)
29 . Validation loss:  tensor(0.0663)
30 . Training loss:  tensor(0.1610)
30 . Validation loss:  tensor(0.0674)
31 . Training loss:  tensor(0.1485)
31 . Validation loss:  tensor(0.0685)
32 . Training loss:  tensor(0.1371)
32 . Validation loss:  tensor(0.0701)
33 . Training loss:  tensor(0.1269)
33 . Validation loss:  tensor(0.0718)
34 . Training loss:  tensor(0.1178)
34 . Validation loss:  tensor(0.0739)
35 . Training loss:  tensor(0.1097)
35 . Validation loss:  tensor(0.0758)
36 . Training loss:  tensor(0.1025)
36 . Validation loss:  tensor(0.0773)
37 . Training loss:  tensor(0.0961)
37 . Validation loss:  tensor(0.0790)
38 . Training loss:  tensor(0.0903)
38 . Validation loss:  tensor(0.0802)
39 . Training loss:  tensor(0.0847)
39 . Validation loss:  tensor(0.0810)
40 . Training loss:  tensor(0.0795)
40 . Validation loss:  tensor(0.0803)
41 . Training loss:  tensor(0.0746)
41 . Validation loss:  tensor(0.0804)
42 . Training loss:  tensor(0.0699)
42 . Validation loss:  tensor(0.0786)
43 . Training loss:  tensor(0.0655)
43 . Validation loss:  tensor(0.0780)
44 . Training loss:  tensor(0.0617)
44 . Validation loss:  tensor(0.0775)
45 . Training loss:  tensor(0.0584)
45 . Validation loss:  tensor(0.0760)
46 . Training loss:  tensor(0.0555)
46 . Validation loss:  tensor(0.0755)
47 . Training loss:  tensor(0.0530)
47 . Validation loss:  tensor(0.0750)
48 . Training loss:  tensor(0.0508)
48 . Validation loss:  tensor(0.0741)
49 . Training loss:  tensor(0.0490)
49 . Validation loss:  tensor(0.0733)
50 . Training loss:  tensor(0.0474)
50 . Validation loss:  tensor(0.0724)
51 . Training loss:  tensor(0.0459)
51 . Validation loss:  tensor(0.0715)
52 . Training loss:  tensor(0.0447)
52 . Validation loss:  tensor(0.0712)
53 . Training loss:  tensor(0.0436)
53 . Validation loss:  tensor(0.0702)
54 . Training loss:  tensor(0.0426)
54 . Validation loss:  tensor(0.0695)
55 . Training loss:  tensor(0.0418)
55 . Validation loss:  tensor(0.0681)
56 . Training loss:  tensor(0.0410)
56 . Validation loss:  tensor(0.0672)
57 . Training loss:  tensor(0.0404)
57 . Validation loss:  tensor(0.0667)
58 . Training loss:  tensor(0.0397)
58 . Validation loss:  tensor(0.0659)
59 . Training loss:  tensor(0.0390)
59 . Validation loss:  tensor(0.0650)
60 . Training loss:  tensor(0.0385)
60 . Validation loss:  tensor(0.0646)
61 . Training loss:  tensor(0.0379)
61 . Validation loss:  tensor(0.0637)
62 . Training loss:  tensor(0.0373)
62 . Validation loss:  tensor(0.0633)
63 . Training loss:  tensor(0.0367)
63 . Validation loss:  tensor(0.0625)
64 . Training loss:  tensor(0.0362)
64 . Validation loss:  tensor(0.0620)
65 . Training loss:  tensor(0.0357)
65 . Validation loss:  tensor(0.0614)
66 . Training loss:  tensor(0.0352)
66 . Validation loss:  tensor(0.0607)
67 . Training loss:  tensor(0.0347)
67 . Validation loss:  tensor(0.0601)
68 . Training loss:  tensor(0.0341)
68 . Validation loss:  tensor(0.0595)
69 . Training loss:  tensor(0.0336)
69 . Validation loss:  tensor(0.0589)
70 . Training loss:  tensor(0.0330)
70 . Validation loss:  tensor(0.0583)
71 . Training loss:  tensor(0.0325)
71 . Validation loss:  tensor(0.0577)
72 . Training loss:  tensor(0.0319)
72 . Validation loss:  tensor(0.0572)
73 . Training loss:  tensor(0.0314)
73 . Validation loss:  tensor(0.0564)
74 . Training loss:  tensor(0.0309)
74 . Validation loss:  tensor(0.0558)
75 . Training loss:  tensor(0.0303)
75 . Validation loss:  tensor(0.0553)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/sphinx_training_colab_9_1.png" src="../_images/sphinx_training_colab_9_1.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Best validation error:  75
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/sphinx_training_colab_9_3.png" src="../_images/sphinx_training_colab_9_3.png" />
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/sphinx_training_colab_9_4.png" src="../_images/sphinx_training_colab_9_4.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Calculating the model&#39;s error for each battery separately:</span>
<span class="n">Load_Save</span><span class="p">(</span><span class="n">date</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">dataset_name</span><span class="o">=</span><span class="n">dataset_name</span><span class="p">,</span> <span class="n">denormalize_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>

<span class="k">if</span> <span class="n">dataset_name</span> <span class="o">==</span> <span class="s1">&#39;MIT&#39;</span><span class="p">:</span>
    <span class="n">Load_Save_v2</span><span class="p">(</span><span class="n">date</span><span class="p">,</span> <span class="n">dataset_name</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span>
                 <span class="n">time_step</span><span class="o">=</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">time_step</span><span class="p">,</span> <span class="n">norm_test</span><span class="o">=</span><span class="s1">&#39;Model&#39;</span><span class="p">,</span>
                 <span class="n">cycle_lim</span><span class="o">=</span><span class="n">cycle_lim</span><span class="p">,</span> <span class="n">denormalize_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0005
165
B0006
166
B0007
165
B0018
130
B0025
27
B0026
24
B0027
27
B0028
27
B0029
40
B0030
40
B0031
40
B0032
40
B0033
180
B0034
188
B0036
192
B0038
44
B0039
42
B0040
43
B0041
25
B0042
64
B0043
64
B0044
65
B0045
68
B0046
66
B0047
67
B0048
68
B0053
55
B0054
101
B0055
98
B0056
100
B0005.txt
B0006.txt (used in training)
B0007.txt
B0018.txt
B0025.txt
B0026.txt
B0027.txt
B0028.txt
B0029.txt
B0030.txt (used in training)
B0031.txt
B0032.txt
B0033.txt
B0034.txt
B0036.txt
B0038.txt (used in training)
B0039.txt (used in training)
B0040.txt
B0041.txt (used in training)
B0042.txt
B0043.txt
B0044.txt
B0045.txt (used in training)
B0046.txt
B0047.txt
B0048.txt
B0053.txt
B0054.txt
B0055.txt (used in training)
B0056.txt
B0005.txt
B0006.txt (used in training)
B0007.txt
B0018.txt
B0025.txt
B0026.txt
B0027.txt
B0028.txt
B0029.txt
B0030.txt (used in training)
B0031.txt
B0032.txt
B0033.txt
B0034.txt
B0036.txt
B0038.txt (used in training)
B0039.txt (used in training)
B0040.txt
B0041.txt (used in training)
B0042.txt
B0043.txt
B0044.txt
B0045.txt (used in training)
B0046.txt
B0047.txt
B0048.txt
B0053.txt
B0054.txt
B0055.txt (used in training)
B0056.txt
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Optional : evaluating the model&#39;s performance for each dataset:</span>

<span class="c1"># Adapt the following code to your needs:</span>
<span class="c1"># Read Load_Save_v2&#39;s documentation to know more. Most importantly,</span>
<span class="c1"># read about the time_step, norm_test variables.</span>
<span class="c1"># for dataset_name in [&#39;NASA&#39;, &#39;MIT&#39;, &#39;Tarascon Coin&#39;]:</span>
<span class="c1">#     Load_Save_v2(date, dataset_name, device=device,</span>
<span class="c1">#                 time_step=train_dataset.time_step, norm_test=&#39;Model&#39;,</span>
<span class="c1">#                 cycle_lim=cycle_lim, denormalize_bool=False)</span>
</pre></div>
</div>
</div>
</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                
    <a class='left-prev' id="prev-link" href="Colabs.html" title="previous page">Google Colabs</a>
    <a class='right-next' id="next-link" href="normalisation_training.html" title="next page"><strong>Normalisation Training Colab</strong></a>

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2022, Antonio ROCHA AZEVEDO.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>